// all code for the display

#define D3 4
#define D5 5
int page_delay = 0;

int screen_count = 0;

SSD1306Wire  display(0x3c, D3, D5);

int page_c = 0;

void display_init(){
  Serial.println("Initiating Display");
  display.init();
  display.flipScreenVertically();
  dev_status="Starting...";

}

void status_page(){
  
}

void dev_status_page(){
  Serial.println("Now showing dev status page");
  display.clear();
  display.setTextAlignment(TEXT_ALIGN_LEFT);
  display.setFont(ArialMT_Plain_10);
  display.drawString(0, 0, "Status");
  display.setFont(ArialMT_Plain_16);
  display.drawString(0, 26, dev_status);
  display.display();
}

void main_page() {
    Serial.println("Now showing main page");
    display.clear();
    display.setTextAlignment(TEXT_ALIGN_LEFT);
    display.setFont(ArialMT_Plain_10);
    display.drawString(0, 0, "Main");
    display.setFont(ArialMT_Plain_24);
    display.drawString(0, 15, "H2HC 2018");
    display.display();
}

void message_page() {
    Serial.println("Now showing message page");
    display.clear();
    display.setTextAlignment(TEXT_ALIGN_LEFT);
    display.setFont(ArialMT_Plain_10);
    display.drawString(0, 0, "Last Message");
    display.setFont(ArialMT_Plain_16);
    display.drawStringMaxWidth(0, 15, 128, inc_msg);
    display.display();
}

void inc_debug_page() {
    Serial.println("Now showing incoming debug page");
    display.clear();
    display.setTextAlignment(TEXT_ALIGN_LEFT);
    display.setFont(ArialMT_Plain_10);
    display.drawString(0, 0, "Incoming debug");
    display.setFont(ArialMT_Plain_16);
    display.drawStringMaxWidth(0, 15, 128, last_inp);
    display.display();
}

void name_page() {
    Serial.println("Now showing Name");
    display.clear();
    display.setTextAlignment(TEXT_ALIGN_LEFT);
    display.setFont(ArialMT_Plain_10);
    display.drawString(0, 0, "Hello, my name is");
    display.setFont(ArialMT_Plain_16);
    display.setTextAlignment(TEXT_ALIGN_LEFT);
    display.drawStringMaxWidth(0, 20, 128,
      o_name);
    display.display();
}

void display_loop(){
  page_delay -= 1;
  if (page_delay < 2){
    Serial.println("Changing page");
    screen_count += 1;
    if (screen_count > 4) {
      screen_count = 0;
    }
    switch (screen_count){
    case 0:{
        page_delay = 9000000;
        main_page();
        break;
        }
    case 1:{
      page_delay = 9000000;
      message_page();
      break;
      }
    case 2:{
      page_delay = 3000000;
      dev_status_page();
      break;
      }
    case 3:{
      page_delay = 3000000;
      inc_debug_page();
      break;
      }
    case 4:{
      page_delay = 9900000;
      name_page();
      break;
      }
    }
  }
}
